<?php  
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class Sirve_Manager_Columns{

    private static $_instance = null;
    public static function instance(){
        if( is_null( self::$_instance ) ){
            self::$_instance = new self();
        }
        return self::$_instance;
    }

    function __construct(){
		// Template type column.
		add_action( 'manage_sirve_posts_columns', [ $this, 'manage_columns' ] );
		add_action( 'manage_sirve_posts_custom_column', [ $this, 'columns_content' ], 10, 2 );		
    }

    // Manage Post Table columns
	public function manage_columns( $columns ) {

		$column_date 	= $columns['date'];
		unset( $columns['date'] );

		$columns['shortcode'] 	    = esc_html__('Shortcode', 'sirve');
		$columns['date'] 		    = esc_html( $column_date );
		return $columns;
	}

    //Manage Columns Content
    public function columns_content( $column_name, $post_id ) {
        if( $column_name === 'shortcode' ){
            echo esc_html__( '[sirve id="' . $post_id . '"]', 'sirve' );
        }
    }
}
Sirve_Manager_Columns::instance();