(function ($) {
  "use strict";
  sirvePagination();

  // Ajax All Search request
  $(document).ready(function () {
    $(".sirve__search-input").keyup(function (e) {
      var $this = $(this);
      clearTimeout($.data(this, "timer"));
      if (e.keyCode == 13) {
        doSearch($this);
      } else {
        doSearch($this);
        $(this).data("timer", setTimeout(doSearch, 100));
      }
    });
    
    // Ajax Catagory Search request
    $(".sirve__nav-tabs li").on("click", function () {
      document.getElementById("sirve__search-input-field").value = "";
      var sirveCategorie = $(this).find("button").data("category");
      var options = $(this).closest('.sirve__container').data('sirveoptions');
      
      $.ajax({
        url: sirve.ajaxurl,
        data: {
          action: "sirve_category_search",
          sirveCategorie: sirveCategorie,
          options: options,
          nonce: sirve.ajaxnonce,
        },
        beforeSend: function () {
          $(".sirve__body").addClass("beforeLoader");
          $(".sirve-loader").addClass("sirve-after-loader");
        },
        success: function (response) {
          $(".sirve-ajax-search").html(response);
          sirvePagination();
          $(".sirve__body").removeClass("beforeLoader");
          $(".sirve-loader").removeClass("sirve-after-loader");
        },
        error: function (errorThrown) {
          console.log(errorThrown);
        },
      });
    });

    // Listing Pagination
    $(document).on("click", ".sirve-pagination a", function () {
      var sirvekey = $(this).data().sirvekey;
      var options = $(this).closest('.sirve__container').data('sirveoptions');  
      var page = $(this).data().page;
      $.ajax({
        url: sirve.ajaxurl,
        data: {
          action: "sirve_category_search",
          sirveCategorie: sirvekey,
          page: page,
          options: options,
          nonce: sirve.ajaxnonce,
        },
        beforeSend: function () {
          $(".sirve__body").addClass("beforeLoader");
          $(".sirve-loader").addClass("sirve-after-loader");
        },
        success: function (response) {
          $(".sirve-ajax-search").html(response);
          $(".sirve-ajax-search").addClass("sirve__row");
          sirvePagination();

          $(".sirve-loader").removeClass("sirve-after-loader");
          $(".sirve__body").removeClass("beforeLoader");
        },
        error: function (errorThrown) {
          console.log(errorThrown);
        },
      });
    });

    //Sirve Search Pagination
    $(document).on("click", ".sirve-search-pagination a", function () {
      var sirvekey = $(this).data().sirvekey;
      var page = $(this).data().page;
      $.ajax({
        url: sirve.ajaxurl,
        data: {
          action: "sirve_search",
          page: page,
          s: sirvekey,
          nonce: sirve.ajaxnonce,
        },
        beforeSend: function () {
          $(".sirve__body").addClass("beforeLoader");
          $(".sirve-loader").addClass("sirve-after-loader");
        },
        success: function (response) {
          $(".sirve-ajax-search").html(response);
          $(".sirve-ajax-search").addClass("sirve__row");
          sirvePagination();
          $(".sirve-loader").removeClass("sirve-after-loader");
          $(".sirve__body").removeClass("beforeLoader");
        },
        error: function (errorThrown) {
          console.log(errorThrown);
        },
      });
    });
  });

  //sirve Pagination
  function sirvePagination() {
    $(".sirve-ajax-search").on( "click", ".ajaxpagination a", function (event) {
        event.preventDefault();

        var link = $(this).attr("href");
        $(".sirve-ajax-search").addClass("loading");

        $(".sirve-ajax-search").load(link + " .ajaxcontent", function () {
          $(".sirve-ajax-search").removeClass("loading");
        });
      }
    );
  }

  //Sirve Search
  function doSearch($this = "") {
    if ($this.length > 0) {
      var searchString = $this.val();
      $(".sirve__nav-link").removeClass("active");
      $(".scarch-item").addClass("active");

      if(searchString == ''){
        allListing_search(searchString);
      }
      //wasn't enter, not < 3 char
      if ( searchString.length >= 3 ){
        allListing_search(searchString);
      }
    }
  }

  function allListing_search(searchString){
    $.ajax({
      url: sirve.ajaxurl,
      data: {
        action: "sirve_search",
        s: searchString,
        nonce: sirve.ajaxnonce,
      },
      beforeSend: function () {
        $(".sirve__body").addClass("beforeLoader");
        $(".sirve-loader").addClass("sirve-after-loader");
      },
      success: function (response) {
        $(".sirve-ajax-search").html(response);
        $(".sirve-ajax-search").addClass("sirve__row");

        sirvePagination();
        $(".sirve-loader").removeClass("sirve-after-loader");
        $(".sirve__body").removeClass("beforeLoader");
      },
      error: function (errorThrown) {
        console.log(errorThrown);
      },
    }).done(function (response) {});
  }

  $('.sirve__container').each(function(){
    var options = $(this).data('sirveoptions');
    $.ajax({
      url: sirve.ajaxurl,
      data: {
        action: "sirve_category_search",
        sirveCategorie: "all",
        options: options,
        nonce: sirve.ajaxnonce,
      },
      beforeSend: function () {},
      success: function (response) {
        $(".sirve-ajax-search").html(response);
        sirvePagination();
      },
      error: function (errorThrown) {
        console.log(errorThrown);
      },
    });
  });

})(jQuery);