<?php

// Sirve Coustom css
function sirve_coustom_css(){
    $buttonTextColor1 = sirve_generate_css( 'color', esc_attr(get_option('sirve_button_1_text_color')) , '', '!important');
    $buttonTextHoverColor1 = sirve_generate_css( 'color', esc_attr(get_option('sirve_button_1_text_hover_color')) , '!important');
    $buttonBgColor1 = sirve_generate_css( 'background', esc_attr(get_option('sirve_button_1_bg_color')) , '', '!important');
    $buttonBgHoverColor1 = sirve_generate_css( 'background', esc_attr(get_option('sirve_button_1_bg_hover_color')) , '', '!important');
    $buttonBorderColor1 = sirve_generate_css( 'border', (!empty(get_option('sirve_button_1_boder_color'))) ?  '1px solid '.esc_attr(get_option('sirve_button_1_boder_color')) : '' , '', '!important');

    $buttonTextColor2 = sirve_generate_css( 'color', esc_attr(get_option('sirve_button_2_text_color')) , '', '!important');
    $buttonTextHoverColor2 = sirve_generate_css( 'color', esc_attr(get_option('sirve_button_2_text_hover_color')) , '!important');
    $buttonBgColor2 = sirve_generate_css( 'background', esc_attr(get_option('sirve_button_2_bg_color')) , '', '!important');
    $buttonBgHoverColor2 = sirve_generate_css( 'background', esc_attr(get_option('sirve_button_2_bg_hover_color')) , '', '!important');
    $buttonBorderColor2 = sirve_generate_css( 'border', (!empty(get_option('sirve_button_2_boder_color'))) ?  '1px solid '.esc_attr(get_option('sirve_button_2_boder_color')) : '' , '', '!important');

    $all_style ="
        .sirve__button-live {{$buttonTextColor1} {$buttonBgColor1} {$buttonBorderColor1}}
        .sirve__button-live:hover {{$buttonBgHoverColor1} {$buttonTextHoverColor1} {$buttonBorderColor1}}

        .sirve__button-visit {{$buttonTextColor2} {$buttonBgColor2} {$buttonBorderColor2}}
        .sirve__button-visit:hover {{$buttonBgHoverColor2} {$buttonTextHoverColor2} {$buttonBorderColor2}}
    ";

    $all_style .= get_option('sirve_coustom_css');
    
    return $all_style;
}

// Sirve Generate Css
function sirve_generate_css( $css_attr, $parameter, $unit = '', $important = '' ){

    $value = !empty( $parameter ) ? $parameter : '';
    if( !empty( $value ) ){
        $css_attr .= ":{$value}{$unit}";
        return $css_attr." {$important};";
    }else{
        return false;
    }
}

// Sirve paginaton
function sirve_pagination($query, $currentPage, $catagoryName, $className = "sirve-pagination"){

    $sirve_par_pages = 0;
    if(!empty(get_option('sirve_par_pages'))){
        $sirve_par_pages = get_option('sirve_par_pages');
    }else{
        $sirve_par_pages = 15;
    }

    $total_page = (int) ceil($query->found_posts/$sirve_par_pages);


    sirve_post_render($query, false);?>
    <div class="sirve__col-lg-12">
        <div class="sirve-pagination-style <?php  echo  esc_attr( $className ) ?>">

            <?php 
            $paginatonNumber = $currentPage-1;
            if($paginatonNumber < 0){
                $paginatonNumber = 0;
            }

            if(!$currentPage == 0): ?>
            <a data-sirvekey="<?php echo esc_attr( $catagoryName ); ?>" data-page="<?php echo esc_attr( $paginatonNumber ); ?>" ><?php echo esc_html__( '&laquo; Previous', 'sirve' ) ?> </a>
            <?php endif;
            $more = true;
            for($i = $paginatonNumber; $i < $total_page; $i++): 
                $j = $i + 1;

                if( $i > $currentPage + 2 && $total_page-1 > $i ){
                    
                    if($more){
                        ?><a class='sirve-pointer'><?php echo esc_html__( '...', 'sirve' ) ?></a><?php
                        $more = false;
                    }
                    continue;
                }

                if($total_page == 1){
                    break;
                }?>
                    <a  <?php if($currentPage == $i): ?> class="active" <?php endif; ?> data-sirvekey="<?php echo esc_attr( $catagoryName ); ?>" data-page="<?php echo esc_attr( $i ); ?>" ><?php echo esc_attr( $j ); ?></a>
                
            <?php endfor; $more = true;
            if(!($total_page-1 == $currentPage)): ?>
                <a data-sirvekey="<?php echo esc_attr( $catagoryName ); ?>" data-page="<?php echo esc_attr( $currentPage+1 ); ?>" ><?php echo esc_html__( 'Next &raquo;', 'sirve' )  ?></a>
            <?php endif; ?>
        </div>  
    </div>
<?php
}