<?php
function sirve_post_render( $query, $loder=true, $shortcode=false ){
    while($query->have_posts()):
        $query->the_post();
        //Disable Single Page:
        $sirveSinglePage = get_option( 'sirve_single_page' );
        //Sirve Feature Text
        $sirveFeatured = get_post_meta( get_the_ID(), 'htSirveFeatureText', true );
        //Post Grid Word
        $show_post_word = (!empty( get_option('sirve_post_grid_word'))) ?  get_option('sirve_post_grid_word') : 40;
        //Featured Image
        $sirveItemImage = wp_get_attachment_image_src( get_post_thumbnail_id(), 'large');
        //Featured Image Alt
        $sirveItemImageAlt = get_post_meta( get_post_thumbnail_id(), '_wp_attachment_image_alt', true ); 
        // Button Text 1
        $sirveButtonText1 = esc_html__( 'Live Preview', 'sirve' );
        if(!empty( get_post_meta( get_the_ID(), 'htSirveButtonText', true ) )){
            $sirveButtonText1 = get_post_meta( get_the_ID(), 'htSirveButtonText', true );
        }elseif( !empty( get_option('sirve_button_text_1'))){
            $sirveButtonText1 = get_option('sirve_button_text_1');
        }
        // Buttion 1 URL
        $sirveButtonUrl1 = get_post_meta( get_the_ID(), 'htSirveButtonUrl', true );
        // Buttion 1 URL Target
        $sirveButtonUrltarget = get_post_meta( get_the_ID(), 'htSirveButtonUrlTarget', true );
        // Single Page Button Text
        $sirveButtonText2 = "";
        if(!($sirveSinglePage == "yes")){
            $sirveButtonText2 = esc_html__( 'More Details', 'sirve' );
            if( !empty( get_option('sirve_single_page_button_text'))){
                $sirveButtonText2 = get_option('sirve_single_page_button_text');
            }
        }else{
            $sirveButtonText2 = esc_html__( 'More Details', 'sirve' );
            if(!empty( get_post_meta( get_the_ID(), 'htSirveButtonText2', true ) )){
                $sirveButtonText2 = get_post_meta( get_the_ID(), 'htSirveButtonText2', true );
            }elseif( !empty( get_option('sirve_single_page_button_text')) ){
                $sirveButtonText2 = get_option('sirve_single_page_button_text');
            }
        }
        // Post Permalink and Button Target
        $post_permalink = get_permalink();
       
        if( !($sirveSinglePage == 'yes')){
            $post_permalink = get_permalink();
            $sirveButtonTarget2 = '';
        }else{
            $post_permalink = get_post_meta( get_the_ID(), 'htSirveButtonUrl2', true );
            $sirveButtonTarget2 =  get_post_meta( get_the_ID(), 'htSirveButtonUrlTarget2', true );
        }
        ?>   
            <div class="<?php 
            if(!$shortcode){
                echo esc_attr((get_option('sirve_archive_page_style', 'style-1') === 'style-1' || get_option('sirve_archive_page_style') === 'style-3'  ) ? 'sirve__col-lg-4 sirve__mb-30' :  'sirve__col-lg-6 sirve__mb-30');
            }else{
                echo esc_attr('sirve__col-lg-12');
            }
            echo esc_attr( ($shortcode) ? ' sirve__single_list' : '' );
            ?>">
                <div class="<?php 
                if(!$shortcode){
                    if(get_option('sirve_archive_page_style', 'style-1') === 'style-1'):
                        echo esc_attr( 'sirve__card' );
                    elseif(get_option('sirve_archive_page_style') === 'style-2'):
                        echo esc_attr( 'sirve__card-horizontal sirve__card--horizontal' );
                    elseif(get_option('sirve_archive_page_style') === 'style-3'):
                        echo esc_attr( 'sirve__card sirve__card--three' );
                    elseif(get_option('sirve_archive_page_style') === 'style-4'):
                        echo esc_attr( 'sirve__card-horizontal sirve__card--four' );
                    endif;
                }else{
                    echo esc_attr( 'sirve__card-horizontal sirve__card--four' );
                }?>">

                    <!-- Featured Image -->
                    <div class="sirve__thum">
                        <?php if( isset( $sirveItemImage[0]) ): ?>
                            <?php if( $sirveSinglePage == 'yes'): ?>
                                    <img src="<?php the_post_thumbnail_url(); ?>" alt="<?php echo esc_attr( $sirveItemImageAlt )?>">
                            <?PHP else: ?>
                                    <a href="<?php echo esc_attr( $post_permalink ) ?>"><img src="<?php the_post_thumbnail_url(); ?>" alt="<?php echo esc_attr( $sirveItemImageAlt )?>"></a>
                            <?PHP endif;
                               endif; ?>

                        <?php if( $sirveFeatured ): ?>
                            <span class="sirve__featured"><?php echo esc_attr( $sirveFeatured ) ?></span>
                        <?php endif; ?>
                    </div>
                              
                    <div class="sirve__content">
                        <!-- Post Titel -->
                        <?php if( $sirveSinglePage == 'yes'): 
                            the_title('<h3 class="sirve__title">', '</h3>');
                         else: ?>
                            <a href="<?php echo esc_attr( $post_permalink ) ?>"><?php the_title('<h3 class="sirve__title">', '</h3>'); ?></a>
                        <?php endif ?>

                        <!-- Post Content -->
                        <?php if(!empty(get_the_content())): ?>
                            <div class="sirve__des"><?php echo wp_trim_words( get_the_content(), $show_post_word) ?></div>    
                        <?php endif; ?>

                        <!-- List Button -->
                        <div class="sirve__button_box">
                            <?php if( isset($sirveButtonUrl1) && !empty($sirveButtonUrl1)): ?>
                                <a class="sirve__button sirve__button-live" href="<?php echo esc_attr( $sirveButtonUrl1 ) ?>" target="<?php echo esc_attr( $sirveButtonUrltarget ) ?>"><?php echo esc_html( $sirveButtonText1 ) ?></a>
                            <?php endif ?>
                            
                            <?php if(isset($post_permalink) && !$post_permalink == ''): ?>
                                <a class="sirve__button sirve__button-visit" href="<?php echo esc_attr( $post_permalink ) ?>" target="<?php echo esc_attr( $sirveButtonTarget2 )?>" rel="noopener"><?php echo esc_html( $sirveButtonText2 ) ?></a>
                            <?php endif ?>
                        </div>
                    </div>
                </div>
            </div>
        <?php
    endwhile;
}